using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using System.IO;

namespace testAutMote
{
    public class CDriver_AutMote
    {
        #region "############################# ATRIBUTES AND CONSTANTS"
        private Object _driver = null;
        private Hashtable _tableHash = null;
        private const String method_NOMDRIVER = "NomDriver";
        private const String method_INICIAR = "Iniciar";
        private const String method_PARAR = "Parar";
        private const String method_COMPROVARCONNEXIOFISICA = "ComprovarConnexioFisica";
        private const String method_BUIDAR_CUA_MANDOS = "BuidarCuaMandos";
        private const String method_RETORNA_MANDO = "RetornaMando";
        private const String method_AFEGIR_USUARI = "AfegirUsuari";
        private const String method_ESBORRAR_USUARIS = "EsborrarUsuaris";
        private const String method_RETORNA_LLISTA_CONNECTATS = "RetornarMandosConnectats";
        private const String method_RETORNA_INFO_CONNECTATS = "RetornarInfoDispositiusLogats";
        private const String method_AFEGIR_PARAULA_IDIOMA = "AfegirParaulaIdioma";
        private const String method_ESBORRAR_IDIOMES = "EsborrarIdiomes";
        private const String method_ENVIAR_MULTICAST_MISSATGE_PUBLIC = "EnviarMulticastMissatgePublic";
        private const String method_ENVIAR_MULTICAST_ESBORRAR_MISSATGES_PRIVATS = "EnviarMulticastEsborrarMissatgesPrivats";
        private const String method_ENVIAR_SOCKET_ESBORRAR_MISSATGES_PRIVATS = "EnviarSocketEsborrarMissatgesPrivats";
        private const String method_ENVIAR_MULTICAST_DESCONNEXIO = "EnviarMulticastDesconnexio";
        private const String method_ASSIGNAR_NOM_SERVEI = "AssignarNomServei";
        private const String method_RETORNA_LLISTA_MANDOS = "RetornaLlistaMandos";
        private const String method_ENVIAR_MISSATGE_SOCKET = "EnviarMissatgeSocket";
        private const String method_ENVIAR_CANVI_COLOR_BOTO = "EnviarCanviColorBoto";
        private const String method_ENVIAR_CANVI_COLOR_BOTO_TOTHOM = "EnviarCanviColorBotoTothom";
        private const String method_CONFIGURARSONSBOTONS = "ConfigurarSonsBotons";
        private const String method_ENVIAR_DESCONNEXIO_SOCKET = "EnviarDesconnexioMando";
        private const String method_ENVIAR_SO_SOCKET = "EnviarSoMando";

        #endregion

        #region	"############################# CONSTRUCTORS"
        public CDriver_AutMote()
        {
            _tableHash = new Hashtable();
        }
        #endregion


        #region "############################# PUBLIC METHODS"
        public bool InstantiateDriver(String dllFile)
        {
            CMethod itemMethod = null;
            MethodInfo method=null;
            Type[] paramTypes = null;
            bool valueReturn = true;

            if (!File.Exists(dllFile))
            {
                valueReturn = false;
            }
            else
            {
                try
                {
                    // Load DLL file
                    Assembly a = Assembly.LoadFrom(dllFile);
                    // Capture class information
                    Type baseType = a.GetType("SISAPTEC.Drivers.Driver", true, true);

                    // Instanciem la classe
                    _driver = Activator.CreateInstance(baseType);

                    // Load driver methods
                    // ************** DRIVERNAME ***************
                    paramTypes = new Type[0];
                    method = baseType.GetMethod(method_NOMDRIVER, paramTypes);
                    itemMethod = new CMethod(method, 0);
                    _tableHash.Add(method_NOMDRIVER, itemMethod);

                    // ************** INITIATE ***************
                    paramTypes = new Type[4];
                    paramTypes[0] = Type.GetType("System.UInt16");
                    paramTypes[1] = Type.GetType("System.String");
                    paramTypes[2] = Type.GetType("System.UInt16");
                    paramTypes[3] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_INICIAR, paramTypes);
                    itemMethod = new CMethod(method, 4);
                    _tableHash.Add(method_INICIAR, itemMethod);

                    //************** MTODE PARAR ***************
                    paramTypes = new Type[0];
                    method = baseType.GetMethod(method_PARAR, paramTypes);
                    itemMethod = new CMethod(method, 0);
                    _tableHash.Add(method_PARAR, itemMethod);


                    //************** MTODE COMPROVARCONNEXIOFISICA **
                    paramTypes = new Type[0];
                    method = baseType.GetMethod(method_COMPROVARCONNEXIOFISICA, paramTypes);
                    itemMethod = new CMethod(method, 0);
                    _tableHash.Add(method_COMPROVARCONNEXIOFISICA, itemMethod);

                    //************** MTODE BUIDAR_CUA_MANDOS ***************
                    paramTypes = new Type[0];
                    method = baseType.GetMethod(method_BUIDAR_CUA_MANDOS, paramTypes);
                    itemMethod = new CMethod(method, 0);
                    _tableHash.Add(method_BUIDAR_CUA_MANDOS, itemMethod);

                    //************** MTODE RETORNA MANDO *****************
                    paramTypes = new Type[2];
                    paramTypes[0] = Type.GetType("System.String&");
                    paramTypes[1] = Type.GetType("System.String&");
                    method = baseType.GetMethod(method_RETORNA_MANDO, paramTypes);
                    itemMethod = new CMethod(method, 2);
                    _tableHash.Add(method_RETORNA_MANDO, itemMethod);

                    //************** MTODE RETORNA_LLISTA_MANDOS *****************
                    paramTypes = new Type[2];
                    paramTypes[0] = Type.GetType("System.Collections.ArrayList&");
                    paramTypes[1] = Type.GetType("System.Collections.ArrayList&");
                    method = baseType.GetMethod(method_RETORNA_LLISTA_MANDOS, paramTypes);
                    itemMethod = new CMethod(method, 2);
                    _tableHash.Add(method_RETORNA_LLISTA_MANDOS, itemMethod);

                    //************** MTODE AFEGIR_USUARI_SUBHASTA ***************
                    paramTypes = new Type[4];
                    paramTypes[0] = Type.GetType("System.String");
                    paramTypes[1] = Type.GetType("System.String");
                    paramTypes[2] = Type.GetType("System.String");
                    paramTypes[3] = Type.GetType("System.UInt16");
                    method = baseType.GetMethod(method_AFEGIR_USUARI, paramTypes);
                    itemMethod = new CMethod(method, 4);
                    _tableHash.Add(method_AFEGIR_USUARI, itemMethod);

                    //************** MTODE ESBORRAR_USUARIS ***************
                    paramTypes = new Type[0];
                    method = baseType.GetMethod(method_ESBORRAR_USUARIS, paramTypes);
                    itemMethod = new CMethod(method, 0);
                    _tableHash.Add(method_ESBORRAR_USUARIS, itemMethod);

                    //************** MTODE RETORNA_LLISTA_CONNECTATS *****************
                    paramTypes = new Type[1];
                    paramTypes[0] = Type.GetType("System.Collections.ArrayList&");
                    method = baseType.GetMethod(method_RETORNA_LLISTA_CONNECTATS, paramTypes);
                    itemMethod = new CMethod(method, 1);
                    _tableHash.Add(method_RETORNA_LLISTA_CONNECTATS, itemMethod);

                    //************** MTODE RETORNA_INFO_CONNECTATS *****************
                    paramTypes = new Type[1];
                    paramTypes[0] = Type.GetType("System.Collections.ArrayList&");
                    method = baseType.GetMethod(method_RETORNA_INFO_CONNECTATS, paramTypes);
                    itemMethod = new CMethod(method, 1);
                    _tableHash.Add(method_RETORNA_INFO_CONNECTATS, itemMethod);

                    //************** MTODE AFEGIR_PARAULA_IDIOMA ***************
                    paramTypes = new Type[3];
                    paramTypes[0] = Type.GetType("System.String");
                    paramTypes[1] = Type.GetType("System.String");
                    paramTypes[2] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_AFEGIR_PARAULA_IDIOMA, paramTypes);
                    itemMethod = new CMethod(method, 3);
                    _tableHash.Add(method_AFEGIR_PARAULA_IDIOMA, itemMethod);

                    //************** MTODE ESBORRAR IDIOMES ***************
                    paramTypes = new Type[0];
                    method = baseType.GetMethod(method_ESBORRAR_IDIOMES, paramTypes);
                    itemMethod = new CMethod(method, 0);
                    _tableHash.Add(method_ESBORRAR_IDIOMES, itemMethod);

                    //************** MTODE ENVIAR_MULTICAST_MISSATGE_PUBLIC ***************
                    paramTypes = new Type[1];
                    paramTypes[0] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_ENVIAR_MULTICAST_MISSATGE_PUBLIC, paramTypes);
                    itemMethod = new CMethod(method, 1);
                    _tableHash.Add(method_ENVIAR_MULTICAST_MISSATGE_PUBLIC, itemMethod);

                    //************** MTODE ENVIAR_MULTICAST_ESBORRAR_MISSATGES_PRIVATS *******
                    paramTypes = new Type[0];
                    method = baseType.GetMethod(method_ENVIAR_MULTICAST_ESBORRAR_MISSATGES_PRIVATS, paramTypes);
                    itemMethod = new CMethod(method, 0);
                    _tableHash.Add(method_ENVIAR_MULTICAST_ESBORRAR_MISSATGES_PRIVATS, itemMethod);

                    //************** MTODE ENVIAR_SOCKET_ESBORRAR_MISSATGES_PRIVATS *******
                    paramTypes = new Type[1];
                    paramTypes[0] = Type.GetType("System.Collections.ArrayList");
                    method = baseType.GetMethod(method_ENVIAR_SOCKET_ESBORRAR_MISSATGES_PRIVATS, paramTypes);
                    itemMethod = new CMethod(method, 1);
                    _tableHash.Add(method_ENVIAR_SOCKET_ESBORRAR_MISSATGES_PRIVATS, itemMethod);

                    //************** MTODE ENVIAR_MULTICAST_DESCONNEXIO ***************
                    paramTypes = new Type[0];
                    method = baseType.GetMethod(method_ENVIAR_MULTICAST_DESCONNEXIO, paramTypes);
                    itemMethod = new CMethod(method, 0);
                    _tableHash.Add(method_ENVIAR_MULTICAST_DESCONNEXIO, itemMethod);

                    //************** MTODE ASSIGNAR_NOM_SUBHASTA ***************
                    paramTypes = new Type[1];
                    paramTypes[0] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_ASSIGNAR_NOM_SERVEI, paramTypes);
                    itemMethod = new CMethod(method, 1);
                    _tableHash.Add(method_ASSIGNAR_NOM_SERVEI, itemMethod);

                    //************** MTODE ENVIAR_MISSATGE_SOCKET ***************
                    paramTypes = new Type[3];
                    paramTypes[0] = Type.GetType("System.String");
                    paramTypes[1] = Type.GetType("System.String");
                    paramTypes[2] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_ENVIAR_MISSATGE_SOCKET, paramTypes);
                    itemMethod = new CMethod(method, 3);
                    _tableHash.Add(method_ENVIAR_MISSATGE_SOCKET, itemMethod);

                    //************** MTODE ENVIAR_DESCONNEXIO_SOCKET ***************
                    paramTypes = new Type[2];
                    paramTypes[0] = Type.GetType("System.String");
                    paramTypes[1] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_ENVIAR_DESCONNEXIO_SOCKET, paramTypes);
                    itemMethod = new CMethod(method, 2);
                    _tableHash.Add(method_ENVIAR_DESCONNEXIO_SOCKET, itemMethod);

                    //************** MTODE ENVIAR_SO_SOCKET ***************
                    paramTypes = new Type[2];
                    paramTypes[0] = Type.GetType("System.String");
                    paramTypes[1] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_ENVIAR_SO_SOCKET, paramTypes);
                    itemMethod = new CMethod(method, 2);
                    _tableHash.Add(method_ENVIAR_SO_SOCKET, itemMethod);

                    //************** MTODE ENVIAR_CANVI_COLOR_BOTO ***************
                    paramTypes = new Type[6];
                    paramTypes[0] = Type.GetType("System.String");
                    paramTypes[1] = Type.GetType("System.String");
                    paramTypes[2] = Type.GetType("System.UInt16");
                    paramTypes[3] = Type.GetType("System.String");
                    paramTypes[4] = Type.GetType("System.UInt16");
                    paramTypes[5] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_ENVIAR_CANVI_COLOR_BOTO, paramTypes);
                    itemMethod = new CMethod(method, 6);
                    _tableHash.Add(method_ENVIAR_CANVI_COLOR_BOTO, itemMethod);

                    //************** MTODE ENVIAR_CANVI_COLOR_BOTO_TOTHOM ***************
                    paramTypes = new Type[5];
                    paramTypes[0] = Type.GetType("System.String");
                    paramTypes[1] = Type.GetType("System.UInt16");
                    paramTypes[2] = Type.GetType("System.String");
                    paramTypes[3] = Type.GetType("System.UInt16");
                    paramTypes[4] = Type.GetType("System.String");
                    method = baseType.GetMethod(method_ENVIAR_CANVI_COLOR_BOTO_TOTHOM, paramTypes);
                    itemMethod = new CMethod(method, 5);
                    _tableHash.Add(method_ENVIAR_CANVI_COLOR_BOTO_TOTHOM, itemMethod);

                    //************** MTODE CONFIGURAR_SONS_BOTONS ***************
                    paramTypes = new Type[1];
                    paramTypes[0] = Type.GetType("System.Collections.Hashtable");
                    method = baseType.GetMethod(method_CONFIGURARSONSBOTONS, paramTypes);
                    itemMethod = new CMethod(method, 1);
                    _tableHash.Add(method_CONFIGURARSONSBOTONS, itemMethod);
                }
                catch
                {
                    valueReturn = false;
                }
            }
            return (valueReturn);
        }
        public String driverName()
        {
            CMethod itemMethod = null;
            Object valueReturn=null;

            itemMethod = (CMethod)_tableHash[method_NOMDRIVER];
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((String)valueReturn);
        }
        public int Initiate(UInt16 portDevices, String IPMulticast, UInt16 portMulticast, String serviceName)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_INICIAR];
            itemMethod[0] = portDevices;
            itemMethod[1] = IPMulticast;
            itemMethod[2] = portMulticast;
            itemMethod[3] = serviceName;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public int Stop()
        {
            Object valueReturn = 0;
            if (_driver != null)
            {
                CMethod itemMethod = null;
                itemMethod = (CMethod)_tableHash[method_PARAR];
                valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
            }
            return ((int)valueReturn);
        }
        public int ClearReceptionQueue()
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_BUIDAR_CUA_MANDOS];
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public int ReturnReceived(ref String code, ref String key)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_RETORNA_MANDO];
            itemMethod[0] = code;
            itemMethod[1] = key;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
            code = (String)itemMethod.Parameters[0];
            key = (String)itemMethod.Parameters[1];
            return ((int)valueReturn);
        }
        public int ReturnReceivedList(ref ArrayList codeList, ref ArrayList keyList)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_RETORNA_LLISTA_MANDOS];
            itemMethod[0] = codeList;
            itemMethod[1] = keyList;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
            codeList = (ArrayList)itemMethod.Parameters[0];
            keyList = (ArrayList)itemMethod.Parameters[1];
            return ((int)valueReturn);
        }
        public int AddUser(String code, String key, String language, int numFunctions)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_AFEGIR_USUARI];
            itemMethod[0] = code;
            itemMethod[1] = key;
            itemMethod[2] = language;
            itemMethod[3] = numFunctions;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public void DeleteUsers()
        {
            CMethod itemMethod = null;
            itemMethod = (CMethod)_tableHash[method_ESBORRAR_USUARIS];
            itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
        }
        public int ReturnConnectedUsers(ref ArrayList connectedList)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_RETORNA_LLISTA_CONNECTATS];
            itemMethod[0] = connectedList;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
            connectedList = (ArrayList)itemMethod.Parameters[0];
            return ((int)valueReturn);
        }
        public int ReturnInfoLoggedDevices(ref ArrayList deviceList)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_RETORNA_INFO_CONNECTATS];
            itemMethod[0] = deviceList;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
            deviceList = (ArrayList)itemMethod.Parameters[0];
            return ((int)valueReturn);
        }
        public int AddWordToLanguage(String language, String key, String word)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_AFEGIR_PARAULA_IDIOMA];
            itemMethod[0] = language;
            itemMethod[1] = key;
            itemMethod[2] = word;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public void DeleteLanguages()
        {
            CMethod itemMethod = null;
            itemMethod = (CMethod)_tableHash[method_ESBORRAR_IDIOMES];
            itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
        }
        public int SendPublicMessageMulticast(String message)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_ENVIAR_MULTICAST_MISSATGE_PUBLIC];
            itemMethod[0] = message;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public int DeletePrivateMessageFromMulticast()
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_ENVIAR_MULTICAST_ESBORRAR_MISSATGES_PRIVATS];
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public int DeletePrivateMessages(ArrayList exceptions)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_ENVIAR_SOCKET_ESBORRAR_MISSATGES_PRIVATS];
            itemMethod[0] = exceptions;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
            return ((int)valueReturn);
        }
        public void SendDisconnectionMulticast()
        {
            CMethod itemMethod = null;
            itemMethod = (CMethod)_tableHash[method_ENVIAR_MULTICAST_DESCONNEXIO];
            itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
        }
        public void SetServiceName(String name)
        {
            CMethod itemMethod = null;

            itemMethod = (CMethod)_tableHash[method_ASSIGNAR_NOM_SERVEI];
            itemMethod[0] = name;
            itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
        }
        public int SendPrivateMessage(String user, String data)
        {
            return SendPrivateMessage(user, data, "0");
        }
        public int SendPrivateMessage(String user, String data, String sound)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_ENVIAR_MISSATGE_SOCKET];
            itemMethod[0] = user;
            itemMethod[1] = data;
            itemMethod[2] = sound;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public int SendUserDisconnection(String user, String sound)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_ENVIAR_DESCONNEXIO_SOCKET];
            itemMethod[0] = user;
            itemMethod[1] = sound;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public int SendSound(String user, String sound)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_ENVIAR_SO_SOCKET];
            itemMethod[0] = user;
            itemMethod[1] = sound;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public int SendUserColorButtonColor(String user, String buttonKey, int buttonColor, String textColor, int state, String sound)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_ENVIAR_CANVI_COLOR_BOTO];
            itemMethod[0] = user;
            itemMethod[1] = buttonKey;
            itemMethod[2] = buttonColor;
            itemMethod[3] = textColor;
            itemMethod[4] = state;
            itemMethod[5] = sound;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public int SendGlobalColorButtonColor(String buttonKey, int buttonColor, String textColor, int state, String sound)
        {
            CMethod itemMethod = null;
            Object valueReturn = null;

            itemMethod = (CMethod)_tableHash[method_ENVIAR_CANVI_COLOR_BOTO_TOTHOM];
            itemMethod[0] = buttonKey;
            itemMethod[1] = buttonColor;
            itemMethod[2] = textColor;
            itemMethod[3] = state;
            itemMethod[4] = sound;
            valueReturn = itemMethod.Method.Invoke(_driver, itemMethod.Parameters);

            return ((int)valueReturn);
        }
        public void ConfigureButtonSounds(Hashtable buttonSounds)
        {
            CMethod itemMethod = null;

            itemMethod = (CMethod)_tableHash[method_CONFIGURARSONSBOTONS];
            itemMethod[0] = buttonSounds;
            itemMethod.Method.Invoke(_driver, itemMethod.Parameters);
        }

        #endregion

    }

    #region "####################### METHODS CONTAINER CLASS"
    public class CMethod
    {
        #region "CMethod ATRIBUTES AND CONSTANTS"
        private MethodInfo _methodName;
        private Object[] _parameters;
        #endregion
        #region "CMethod PROPIETATS"
        public MethodInfo Method
        {
            get
            {
                return (_methodName);
            }
        }
        public Object[] Parameters
        {
            get
            {
                return (_parameters);
            }
        }
        public Object this[int parameter]
        {
            set
            {
                _parameters[parameter] = value;
            }
        }
        #endregion
        #region "CMethod PUBLIC METHODS AND CONSTRUCTORS"
        public CMethod(MethodInfo method, int numParameters)
        {
            _methodName = method;
            _parameters = new Object[numParameters];
        }
        #endregion
    }
    #endregion
}
